/* FILE: scalarfieldinit.h      -*-Mode: c++-*-
 *
 * Abstract Oxs_ScalarFieldInit class, derives from Oxs_Ext, for
 * initializing Oxs_MeshValue<REAL8m> objects.
 */

#ifndef _OXS_SCALARFIELDINIT
#define _OXS_SCALARFIELDINIT

#include "oc.h"

#include "ext.h"
#include "key.h"
#include "mesh.h"
#include "meshvalue.h"

/* End includes */

////////////////////////////////////////////////////////////////////////
// Oxs_ScalarFieldInit (generic Oxs_Ext scalar field) class
class Oxs_ScalarFieldInit : public Oxs_Ext {
protected:
  // Disable copy constructor and assignment operator by
  // declaring them here and never providing a definition.
  Oxs_ScalarFieldInit(const Oxs_ScalarFieldInit&);
  Oxs_ScalarFieldInit& operator=(const Oxs_ScalarFieldInit&);

  // Constructors
  Oxs_ScalarFieldInit(const char* name,
		      Oxs_Director* newdtr);
  Oxs_ScalarFieldInit(const char* name,Oxs_Director* newdtr,
		      Tcl_Interp* safe_interp,const char* argstr);

public:
  virtual ~Oxs_ScalarFieldInit() {}

  virtual void FillMeshValue(const Oxs_Mesh* mesh,
			     Oxs_MeshValue<REAL8m>& array)
    const =0;
};


#endif // _OXS_SCALARFIELDINIT
