/* FILE: rectangularsection.h                 -*-Mode: c++-*-
 *
 * Abstract section class, derived from OXS extension class.
 *
 */

#ifndef _OXS_RECTANGULARSECTION
#define _OXS_RECTANGULARSECTION

#include "section.h"
#include "util.h"
/* End includes */

class Oxs_RectangularSection:public Oxs_Section {
private:
  Oxs_Box box;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_RectangularSection
  ( const char* name,     // Child instance id
    Oxs_Director* newdtr, // App director
    Tcl_Interp* safe_interp, // Safe interpreter
    const char* argstr);  // MIF input block parameters
  virtual void GetExtents(Oxs_Box &mybox) const;
  virtual BOOL IsIn(const ThreeVector& point) const;
  /// Returns 1 if point is inside section, 0 otherwise.
  /// The lower bound on each coordinate is considered
  /// included in the section, the upper bound is excluded.
  ~Oxs_RectangularSection();
};


#endif // _OXS_RECTANGULARSECTION
