/* FILE: uniformscalarfieldinit.cc     -*-Mode: c++-*-
 *
 * Uniform scalar field initializer, derived from Oxs_ScalarFieldInit
 * class.
 *
 */

#include "oc.h"
#include "nb.h"

#include "uniformscalarfieldinit.h"

// Oxs_Ext registration support
OXS_EXT_REGISTER(Oxs_UniformScalarFieldInit);

/* End includes */


// Constructor
Oxs_UniformScalarFieldInit::Oxs_UniformScalarFieldInit(
  const char* name,     // Child instance id
  Oxs_Director* newdtr, // App director
  Tcl_Interp* safe_interp, // Safe interpreter
  const char* argstr)   // MIF input block parameters
  : Oxs_ScalarFieldInit(name,newdtr,safe_interp,argstr)
{
  // Process arguments.
  CheckInitValueParamCount("value",1);
  value=Nb_Atof((*FindInitValue("value"))[0].c_str());
  DeleteInitValue("value");

  VerifyAllInitArgsUsed();
}

BOOL Oxs_UniformScalarFieldInit::Init()
{ return 1; }

void
Oxs_UniformScalarFieldInit::FillMeshValue
(const Oxs_Mesh* mesh,
 Oxs_MeshValue<REAL8m>& array) const
{
  array.AdjustSize(mesh);
  UINT4m i,size=mesh->Size();
  for(i=0;i<size;i++) array[i]=value;
}
