/* FILE: uniformvectorfieldinit.h     -*-Mode: c++-*-
 *
 * Uniform vector field initializer, derived from Oxs_VectorFieldInit
 * class.
 *
 */

#ifndef _OXS_UNIFORMVECTORFIELDINIT
#define _OXS_UNIFORMVECTORFIELDINIT

#include "oc.h"

#include "vectorfieldinit.h"

/* End includes */

class Oxs_UniformVectorFieldInit:public Oxs_VectorFieldInit {
private:
  ThreeVector vec;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_UniformVectorFieldInit
  (const char* name,     // Child instance id
   Oxs_Director* newdtr, // App director
   Tcl_Interp* safe_interp, // Safe interpreter
   const char* argstr);  // MIF input block parameters

  virtual ~Oxs_UniformVectorFieldInit() {}

  virtual void FillMeshValue(const Oxs_Mesh* mesh,
			     Oxs_MeshValue<ThreeVector>& array) const;

};


#endif // _OXS_UNIFORMVECTORFIELDINIT
