/* FILE: floatvec.cc                 -*-Mode: c++-*-
 * At minimum, this file must exist to quiet HP's CC pre-linker.
 */
#include "floatvec.h"

void Convert(const Nb_Vec3<REAL4> &invec,Nb_Vec3<REAL8> &outvec)
{
  outvec.x=REAL8(invec.x);
  outvec.y=REAL8(invec.y);
  outvec.z=REAL8(invec.z);
}

void Convert(const Nb_Vec3<REAL8> &invec,Nb_Vec3<REAL4> &outvec)
{
  outvec.x=REAL4(invec.x);
  outvec.y=REAL4(invec.y);
  outvec.z=REAL4(invec.z);
}

void Convert(const Nb_BoundingBox<REAL4> &inbox,
	     Nb_BoundingBox<REAL8> &outbox)
{
  Nb_Vec3<REAL4> nmin,nmax;
  Nb_Vec3<REAL8> wmin,wmax;
  inbox.GetExtremes(nmin,nmax);
  Convert(nmin,wmin);
  Convert(nmax,wmax);
  outbox.Set(wmin,wmax);
}

void Convert(const Nb_BoundingBox<REAL8> &inbox,
	     Nb_BoundingBox<REAL4> &outbox)
{
  Nb_Vec3<REAL8> wmin,wmax;
  Nb_Vec3<REAL4> nmin,nmax;
  inbox.GetExtremes(wmin,wmax);
  Convert(wmin,nmin);
  Convert(wmax,nmax);
  outbox.Set(nmin,nmax);
}

